#if defined _knife_choice_core_included
  #endinput
#endif
#define _knife_choice_core_included


/**
knife - номер ножа от 1 до max id
номер ножа - его название
1 - Обычный нож
2 - Золотой нож
3 - Складной нож
4 - Нож с лезвием-крюком
5 - Штык-нож
6 - Штык-нож М9
7 - Керамбит
8 - Охотничий нож
9 - Нож бабочка
10 - Нож-сабля
**/


/**
 **********************************************
 * ПРИВАТНЫЕ СОБЫТИЯ
 **********************************************
**/

/**
 * Игрок получает костюмной нож
 *
 * client 			- игрок
 * knife		    - номер ножа
 * knife_ent	    - Ent ножа
 **/
functag public knife_end(client, knife, knife_ent);

/**
 * Игрок поднимает нож (ножи выдаваемые плагином сюда не входят)
 *
 * (client)
 * client 			- игрок
 **/
functag public give_knife(client);


/**
 **********************************************
 * ФУНКЦИИ
 **********************************************
**/

/**
 * Получить имя ножа по его ид
 *
 * knife		    - номер ножа
 * String:sBuffer[]	- строка куда вписано имя ножа
 * size		        - размер sBuffer
 *
 * return:
 * false	        - ошибка при получении имени ножа
 * true	            - имя получено
**/
native bool:kcc_get_name_knife_id(knife, String:sBuffer[], size);

/**
 * Выдать нож
 *
 * client			- игрок
 * knife		    - номер ножа
 *
 * return:
 * false	        - ошибка при выдаче ножа
 * true	            - нож выдан
**/
native bool:kcc_set_knife(client, knife);

/**
 * У игрока кастюмный нож
 *
 * client			- игрок
 *
 * return:
 * 0	            - у игрока обычный нож
 * от 3 до max id   - ид ножа
**/
native kcc_client_knife_custom(client);


/**
 * Выдать игроку нож чужого игрока
 *
 * client			- игрок
 *
 * return:
 * false	        - ошибка при выдаче ножа
 * true	            - нож выдан
**/
native bool:kcc_set_knife_target_knife(client, target);

/**
 * максимальний ид ножа
 *
 *
 * return:
 * от 1 до max id	   - максимальный ид ножа
**/
native kcc_knife_max_id();

/**
 * Загружено ли ядро
 *
 * return:
 * false	        - ядро незагружено
 * true	            - ядро загружено
**/
native bool:KCC_IsLoaded();

/**
 * Хук перед получением игроком костюмного ножа
 *
 * @param func		Обратный вызов.
**/
native Hook_kcc_obtaining_knife_end(knife_end:func);

/**
 * Хук когда играку выдалса нож
 *
 * @param func		Обратный вызов.
**/
native Hook_give_knife(give_knife:func);


/**
 **********************************************
 * СОБЫТИЯ
 **********************************************
**/

/**
 * Получение ножа
 *
 * client			- игрок
 * target			- игрок нож которого получит client
 * knife		    - номер ножа
 * knifename		- название ножа
 * aknife		    - присуствует ли нож у client
 * return: 
 * Plugin_Handled   - запретить выдачу ножа
 * Plugin_Stop      - запретить выдачу ножа
 * Plugin_Continue  - разрешить выдачу ножа
**/
forward Action:kcc_obtaining_knife(client, target, knife, String:knifename[], bool:aknife);

/**
 * Knife choice CORE загрузился
**/
forward KCC_Loaded();




/**
Shared plugin information
**/
public SharedPlugin:__pl_knife_choice_core = 
{
	name = "knife_choice_core",
	file = "knife_choice_core.smx",
#if defined REQUIRE_PLUGIN
	required = 1
#else
	required = 0
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_knife_choice_core_SetNTVOptional()
{
	MarkNativeAsOptional("kcc_set_knife");
	MarkNativeAsOptional("kcc_get_name_knife_id");
	MarkNativeAsOptional("kcc_client_knife_custom");
	MarkNativeAsOptional("kcc_set_knife_target_knife");
	MarkNativeAsOptional("kcc_knife_max_id");
	MarkNativeAsOptional("KCC_IsLoaded");
	MarkNativeAsOptional("Hook_kcc_obtaining_knife_end");
	MarkNativeAsOptional("Hook_give_knife");
}
#endif